(define (silk-benchmark)
  (define (print x) (write x) (newline) x)
  (define (f n) (if (= n 0) f (f (- n 1))))
  (define (foo n) (print (time (f n) 1)))
  (define n 100000)
  (print (System.getProperties))
  (define g (lambda () (foo n)))
  (define (double g) (lambda () (g) (g)))
  (double (double g))
  '(begin
    (foo n)
    (foo n)
    (foo n)
    (foo n)
    (foo n)
    (foo n)
    (foo n)
    )
  )

(define (guile-benchmark)
  (define (print x) (write x) (newline) x)
  (define (time-of-day)
    (let ((it (gettimeofday)))
      (+ (exact->inexact (car it)) (* (cdr it) 1.0e-6))))
  (define (time thunk)
    (let ((start (time-of-day)))
      (thunk)
      (- (time-of-day) start)))
  (define (f n) (if (= n 0) f (f (- n 1))))
  (define (foo n) (print (time (lambda () (f n)))))
  (define n 100000)
  (begin
    (foo n)
    (foo n)
    (foo n)
    (foo n)
    (foo n)
    (foo n)
    (foo n)
    )
  )
;;; Guile time on birchbeer 110MH sun.

guile> (time (lambda () (f 10000)))
0.352749943733215
guile> (time (lambda () (f 100000)))
5.09727001190186
guile> (time (lambda () (f 100000)))
5.24016308784485
guile> (time (lambda () (f 100000)))
5.18811810016632
guile> (time (lambda () (f 100000)))
5.13561606407166
guile> (time (lambda () (f 100000)))
4.8701479434967
guile> ^CERROR: User interrupt
ABORT: (signal)
guile> 
;;; times from java 1.2.1 on sun:
({silk.Closure f[1] (n)} (3916 msec) (1603704 bytes))
> (time (f 100000) 1)
({silk.Closure f[1] (n)} (39626 msec) (1329392 bytes))
> (time (f 100000) 1)
({silk.Closure f[1] (n)} (39341 msec) (1329392 bytes))
> (time (f 100000) 1)
(/ 39.3 5.18)
({silk.Closure f[1] (n)} (39399 msec) (1329392 bytes))
> 7.586872586872587
> 


(define data '(
    ((961299713 . 47609) (961299712 . 309958))
    ((961299713 . 759319) (961299713 . 64137))
    ((961299714 . 483012) (961299713 . 775419))
    ((961299715 . 204304) (961299714 . 499151))
    ((961299715 . 927488) (961299715 . 220485))
    ((961299715 . 927488) (961299715 . 220485))
))

(define (vert x)
  (define (vert0 it) (+ (exact->inexact (car it)) (* (cdr it) 1.0e-6)))
  (- (vert0 (car x)) (vert0 (cadr x))))

1 0 0
1 1 0
1 1 1