;;; WELCOME to the Java Developer Connection(sm) (JDC) Tech Tips, 
;;; September 23, 1999. This issue covers:

;;;          * Extracting Links from an HTML File

(import "java.io.FileReader")
(import "java.io.InputStreamReader")
(import "java.lang.Boolean")
(import "java.net.URL")
(import "java.net.URLConnection")
(import "javax.swing.text.Document")
(import "javax.swing.text.Element")
(import "javax.swing.text.ElementIterator")
(import "javax.swing.text.SimpleAttributeSet")
(import "javax.swing.text.html.HTML")
(import "javax.swing.text.html.HTML$Attribute")
(import "javax.swing.text.html.HTML$Tag")
(import "javax.swing.text.html.HTMLEditorKit")
(import "jlib.ExceptionHandler")

(define (getReader0 url)
  (InputStreamReader (getInputStream (openConnection url))))

(define getReader
  (ExceptionHandler 
   getReader0
   (lambda (e p args) '())))

;;; Unfortunately, this Class is not an iterator!
(define-method iterate ((items javax.swing.text.ElementIterator) action)
  (let ((item (next items)))
    (if (not (null? item))
	(begin
	  (action item)
	  (iterate items action)))))

(define read-doc
  (ExceptionHandler
   (lambda (kit rd doc)
     (read# kit rd doc 0) #t)
   (lambda (e p args) #f)))

(define (walk-links url how so-far level table)
  (if (and (> level 0) (null? (get table url)))
      (let* ((kit (HTMLEditorKit))
	     (doc (createDefaultDocument kit))
	     (rd (getReader url)))
	;; The Document class does not yet handle charset's properly.
	(print (list level url))
	(put table url #t)
	(if (not (null? rd))
	    (begin
	      (putProperty doc "IgnoreCharsetDirective" Boolean.TRUE)
	      ;; Parse the HTML.
	      (if (read-doc kit rd doc)
		  (begin
		    ;; Iterate through the elements of the HTML document.
		    (set! *doc* doc)
		    (iterate
		     (ElementIterator doc) 
		     (lambda (elem)
		       (let ((s (getAttribute (getAttributes elem) HTML$Tag.A)))
			 (if (not (null? s))
			     (let ((href (getAttribute s HTML$Attribute.HREF)))
			       (if (and (not (null? href))
					(not (= (indexOf href "javascript:") 0))
					(not (= (indexOf href "mailto:") 0)))
				   (let ((u (URL url href)))
				     (set! *s* u)
				     (set! so-far (how url href  so-far))
				     (set! so-far (walk-links u how so-far (- level 1) table)))))))))))))))
      so-far)

(define (how-link page link so-far)
  (let ((r (getReader (URL page link))))
    (if (null? r) (cons (print (list page link)) so-far)	; Collect broken links.
	so-far)))

(define url (URL "http://battle.bbn.com"))
'(walk-links url how-link '() 3 (Hashtable 500))
'(
(http://www.dla.mil/siteindex.htm http://www.emall.dla.mil)
(http://www.dla.mil/other_web.htm http://www.emall.dla.mil)
(http://battle.bbn.com/icis.html /cgi-bin/class3/file-editor.pl)
(http://www.icis.hq.dla.mil/ /cgi-bin/class3/form.pl)
(http://battle.bbn.com/ /cgi-bin/class3/file-editor.pl)
)