// Copyright 2001, Jonathan Bachrach.  See file TERMS.

import java.io.*;
import java.util.*;
import antlr.*;

/**
 * Float literal fragment
 * @author  Jonathan Bachrach
 * @author  Keith Playford
 * @version 0.9, 03OCT00
 */
public class FloatFragment extends LiteralFragment {
    public FloatFragment(Float x) { 
	super(makeToken(JavaTokenTypes.NUM_FLOAT, x.toString())); 
    }   
    public FloatFragment(Token t) { super(t); }   
    public Object getValue() { 
	return new Float(Float.parseFloat(getText()));
    }
    public Fragment compileTemplate(int depth) {
	return Template.processTemplate
	    (FragmentList.fnil
	     .fpush(Template.substituteIdentifier("Template.substituteAsFloat"))
	     .fpush(Template.processParens
		    (FragmentList.fnil
		     .fpush(Template.substituteAsFloat((Float)getValue()))
		     .freverse()))
	     .freverse());
    }
}

