// Copyright 2001, Jonathan Bachrach.  See file TERMS.

import java.io.*;
import java.util.*;

/**
 * A way to return multiple values for two different points in a FragmentList
 * @author  Jonathan Bachrach
 * @author  Keith Playford
 * @version 0.9, 03OCT00
 */
public class SplitList {
    FragmentList left    = FragmentList.FragmentNil;
    FragmentList right   = FragmentList.FragmentNil;
    public FragmentList getLeft()   { return left; }
    public FragmentList getRight()  { return right; }
    public FragmentList getBefore() { return left; }
    public FragmentList getInside() { return left; }
    public FragmentList getAfter()  { return right; }
    public Fragment     getCurrent()   { return left.getFragmentHead(); }
    public void setAfter(FragmentList after)  { right = after; }
    public SplitList(FragmentList left, FragmentList right) {
	this.left  = left;
	this.right = right;
    }
}
